# Made by Xuancheng397
# Using scripts Made by Sora_
# Thanks to the Genshin Impact Modding Community for their help and support
# Thanks to LeoTorreZ and SilentNightSound, this script is adapted from their script
# Thanks for BladeMouX and Plutoisy, for allowing me to find these hashes in advance
# Special thanks for !someone name has 63B long? help me complete this script

# Fixes for nearly all female character's Splash mods
# Do not contain: Splashs of Huohuo, Seele, Fuxuan and Topaz in Databank, Splash of Huohuo in Battle.
# Note: This program only contains few fixes for mods before 2.2, So if this program didn't solve your problem, please find 2.2 version of them and retry.



import os
import struct
import argparse
import shutil

old_vs_new = {
    # Acheron
    #Art
    "8604831b":"668b8b86",
    #BattleArt
    "80075e4f":"931dfde3",
    #BattleOrder
    "ec0e3b1e":"ca55c620",
    #Icon
    "8d9856a1":"c0fcd513",
    #Profile
    "5c63ad84":"b03e294b",
    #Splash
    "62588c58":"b119a0b5",
    #UltArt
#"a03aec06":"",

    # Asta
    #Art
    "14d70e68":"8d341755",
    #BattleArt
    "0ffb5d1c":"543b9bb8",
    #BattleOrder
    "11ccee27":"d5ed2d60",
    #Icon
    "2121ecf0":"0abc0f99",
    #Profile
    "c42e386e":"91f6d40c",
    #Splash
    "5a7fce1a":"9cbc4ad3",
    #UltArt
    "7516525b":"c3548de0",

    # Bailu
    #Art
    "440ebb32":"0bd47bc4",
    #BattleArt
    "d73a170f":"bb184ae1",
    #BattleOrder
    "a7e0228e":"cd2bedcd",
    #Icon
    "7d523c05":"17210ea9",
    #Profile
    "d9cb081e":"94fb3052",
    #Splash
    "9c770e54":"8f164754",
    #UltArt
    "76af465b":"30046397",
    #Trial
    "614a6b44":"0f04af26",

    # Blackswan
    #Art
    "4da82e03":"ef390aed",
    #BattleArt
    "0e2231a5":"730af6ea",
    #BattleOrder
    "db89e14e":"90d432c2",
    #Icon
    "d1e423dd":"d3ade8f7",
    #Profile
    "b6f6ac2a":"5f16e89b",
    #Splash
    "e02be308":"729696e4",
    #UltArt
    "f6e934ab":"5ee3bc37",

    # Bronya
    #Art
    "e612ab0b":"b5b99558",
    #BattleArt
    "3a4df027":"c1264c40",
    #BattleOrder
    "b7886494":"e00031b7",
    #Icon
    "09d65b2c":"22b714e8",
    #Profile
    "526d170d":"d4e33fa6",
    #Splash
    "8bc19214":"58e180ca",
    #UltArt
    "ef16e94f":"7401132b",
    #Trial
    #"3a0cbe53":"",
    #Warpcover
    "839719b2":"8836cd56",

    # Clara
    #Art
    "9d2a08b1":"9a6e07f7",
    #BattleArt
    "41111045":"00ed83cd",
    #BattleOrder
    "6201da8e":"18978b8a",
    #Icon
    "a1ece9f7":"0ce788b5",
    #Profile
    "4181f186":"50c8635c",
    #Splash
    "0d0ff125":"8a5eca91",
    #UltArt
    "fc271dc6":"0d74897c",
    #Trial
    "77d982ac":"ee9d21f9",

    # Fuxuan
    #Art
    "ee37fb06":"75c92596",
    #BattleArt
    "9861ac89":"bb2e1979",
    "a0ff4020":"bb2e1979",
    #BattleOrder
    "6d4c4439":"d856e94a",
    "2f09f884":"d856e94a",
    #Icon
    "ddf52f18":"6c0b9376",
    "ddf52f18":"6c0b9376",
    #Profile
    "c81c6f70":"b8af59ca",
    #Splash
    #"8b52179b":"",
    #UltArt
    "2b7ecdbc":"9af24370",
    "208daa06":"9af24370",

    # Guinaifen
    #Art
    "4c8a02c2":"cbdfbb76",
    #BattleArt
    "bddf1066":"fcb1bb7f",
    #BattleOrder
    "ec6492d1":"3a93f9cc",
    #Icon
    "658b36b0":"c8727636",
    #Profile
    "9f2003d6":"e967b83b",
    #Splash
    "194f5fb8":"8d6d788d",
    #UltArt
    "afbd43fe":"e605a269",

    # Herta
    #Art
    "6c0c1e77":"d38a9b75",
    #BattleArt
    "71296c18":"b743b373",
    #BattleOrder
    "775ae1ef":"dfc93fe9",
    #Icon
    "616c59f0":"1be902f7",
    #Profile
    "4ccc8ac5":"d45a496e",
    #Splash
    "9fba39d6":"ab4db500",
    #UltArt
    "8499d818":"dac1378b",

    # Himeko
    #Art
    "af56cf48":"407e3d8e",
    #BattleArt
    "cbd4ff12":"377c4aba",
    #BattleOrder
    "cd43f2ba":"86e37516",
    #Icon
    "3fa974d4":"3295d673",
    #Profile
    "8ba698e0":"41f42c51",
    #Splash
    "efdb1b5e":"8ec1eb4f",
    #UltArt
    "511d3c5a":"5f23eb6b",

    # Hook
    #Art
    "1c4c9afb":"0d8262a8",
    #BattleArt
    "a2c7fbfc":"3de67ea9",
    #BattleOrder
    "8270d313":"10e4c45e",
    #Icon
    "21682aad":"b41e3330",
    #Profile
    "121d8508":"a2a3d5ec",
    #Splash
    "6eeafacc":"e9c254c7",
    #UltArt
    "6eeafacc":"2d99ba6d",

    # Huohuo
    #Art
    "99fddd76":"69275546",
    #BattleArt
    "bbc6bdaa":"abfc6e41",
    #BattleOrder
    "b06ea16c":"ced33b40",
    #Icon
    "3e284e3b":"6d15a97d",
    #Profile
    "d32e0e7f":"d48efaf6",
    #Splash
    #"f3159e7e":"",
    #UltArt
    #"9033e6c9":"",

    # Jingliu
    #Art
    "5ec23d25":"6735f278",
    #BattleArt
    "1675c0b1":"8b0e0f0d",
    "52d64287":"8b0e0f0d",
    #BattleOrder
    "3c95cec0":"ef0f107f",
    "4b00e570":"ef0f107f",
    #Icon
    "91d1796b":"32a951d3",
    #Profile
    "20fce92b":"18404fd6",
    "22f97796":"18404fd6",
    #Splash
    "8ac14b9a":"fc8148a9",
    #UltArt
    "3d9e0381":"a898f9ea",

    # Kafka
    #Art
    "8479906a":"43df8421",
    #BattleArt
    "06cf3072":"c88f2db1",
    #BattleOrder
    "180d488b":"d3936da4",
    #Icon
    "7b9c65df":"3c6f489b",
    #Profile
    "e244353f":"fb096375",
    #Splash
    "76701453":"c7f2ab8f",
    #UltArt
    "b14f60bf":"1d526fd0",
    #FollowUp
    "3aa492bf":"5178414c",

    # Lynx
    #Art
    "99038f41":"6c9d7255",
    #BattleArt
    "5eee03a8":"09d670ff",
    #BattleOrder
    "2f861a26":"41362fc5",
    #Icon
    "2f988f66":"5d802de1",
    #Profile
    "c4872d5c":"5d3ee015",
    #Splash
    "8760a2a7":"3fdb7ecc",
    #UltArt
    "dfdcbaec":"d4be4451",

    # March7th
    #Art
    "3580ca1f":"9e658c73",
    #BattleArt
    "41184274":"ccf6a68e",
    #BattleOrder
    "e636c80":"f2e46b69",
    #Icon
    "818cdf2c":"0079c9ae",
    #Profile
    "2ac301c3":"2786bc13",
    #Splash
    "dc875524":"3fb14dda",
    #UltArt
    "72803b0c":"9a32c18d",
    #FollowUp
    "930542b9":"0f4bdf59",

    # Pela
    #Art
    "1013222d":"c89f6c6e",
    #BattleArt
    "6344a766":"9066a953",
    #BattleOrder
    "52a75804":"91e1886b",
    #Icon
    "24576a22":"18987536",
    #Profile
    "817e52e3":"c870beb0",
    #Splash
    "d223f76c":"5e8fe4fb",
    #UltArt
    "76c7b2c3":"dc4f6a95",

    # Qingque
    #Art
    "05b0a6cc":"7aaf944e",
    #BattleArt
    "b677ca67":"6aa5031a",
    #BattleOrder
    "fb0c1ca1":"6b9ec83f",
    #Icon
    "e177fb34":"14ed4fa9",
    #Profile
    "b7d74859":"c0281bbd",
    #Splash
    "3167a991":"b1cebccc",
    #UltArt
    "8da24199":"a1e2df2c",

    # Robin
    #Art
    "aa167ac2":"754da694",
    #BattleArt
    "5fc8ac4c":"af88e30a",
    #BattleOrder
    "b2b8947c":"d546bf1a",
    #Icon
    "71c73464":"5d1cd628",
    #Profile
    "39543769":"5c5c82ac",
    #Splash
    "feb1546e":"fa54764a",
    #UltArt
    #"d6476d19":"",

    # Ruanmei
    #Art
    "1c383d46":"d20651fc",
    #BattleArt
    "27f0141d":"4b3646ad",
    #BattleOrder
    "70bbb345":"22226405",
    #Icon
    "5b64dd29":"11bff036",
    #Profile
    "b868e90a":"af29ab75",
    #Splash
    "125d5b1d":"c4308920",
    #UltArt
    "0a7fe5fc":"33aece8b",
    #Trial
    #"ac6c3d83":"9dda51af",
    #Warp
    "104204dc":"d095bcfc",
    #Dome
    "28e480d8":"947e70c4",

    # Seele
    #Art
    "88b5b26e":"8892260a",
    #BattleArt
    "e74f7d10":"569f2e6c",
    #BattleOrder
    "18c218eb":"e5d6bb37",
    #Icon
    "49bef924":"b873ff17",
    #Profile
    "4f846dd7":"762ae84f",
    #Splash
    #"a2e967d3":"",
    #UltArt
    "c2e0b7f5":"9b91a592",

    # Serval
    #Art
    "f0c06391":"ef7fb02a",
    #BattleArt
    "d854d3e6":"704db3e4",
    #BattleOrder
    "b1b2c399":"8e325a4b",
    #Icon
    "f2df3e43":"bc623d27",
    #Profile
    "2803f34f":"078ff1d9",
    #Splash
    "50b8afe2":"89f53f87",
    #UltArt
    "e4a2fa78":"abdb5c6b",

    # Silverwolf
    #Art
    "2003c4f2":"659437c3",
    #BattleArt
    "bd6b9e60":"029a0652",
    #BattleOrder
    "3b7637d3":"1c65eb04",
    #Icon
    "bc35c63a":"33f9d998",
    #Profile
    "edf6f9f1":"d925b98c",
    #Splash
    "58f4f460":"4e10b0a9",
    #UltArt
    "32eb2178":"eba0a430",

    # Sparkle
    #Art
    "ef388f76":"88f201e9",
    #BattleArt
    "4885813b":"8f0b3be7",
    #BattleOrder
    "c8d5881e":"b0eddbdb",
    #Icon
    "b5186df1":"5b2e439d",
    #Profile
    "4328956e":"26973cd8",
    #Splash
    "20543deb":"16c3c57d",
    #UltArt
    "ccb618e1":"a9d6c0d2",

    # Stelle Harmony
    #Art
    "95a597b9":"88816336",
    #BattleArt
    "5a283fbc":"9600960e",
    #BattleOrder
    "538d49e7":"dac7efbe",
    #Icon
    "070c56c1":"54b45d65",
    #Profile
    "70d3d787":"98cc9071",
    #Splash
    "e48d797d":"4b8b55ec",
    #UltArt
    #"f3ce333e":"",

    # Stelle Preservation
    #Art
    "7bcfadf1":"ff5d2b33",
    #BattleArt
    "983e7b5a":"e0fa5246",
    #BattleOrder
    "ea8bf14b":"8daee388",
    #Icon
    "0d2d9e70":"924f03fd",
    #Profile
    "d644a5e8":"716c7608",
    #Splash
    "e4a4a550":"f2bce8b6",
    #UltArt
    "ead02b0d":"eba81d41",

    # Stelle Destruction
    #Art
    "e74b53fc":"a472f1b6",
    #BattleArt
    "914ed2f9":"1fae17f5",
    #BattleOrder
    "ca6970bd":"d8563a7a",
    #Icon
    "f4603347":"60f4559d",
    #Profile
    "7ad33534":"ba55cf4f",
    #Splash
    "e3cbdd32":"de384493",
    #UltArt
    "62e80a0c":"597d5054",

    # Sushang
    #Art
    "57335c0c":"dde57e03",
    #BattleArt
    "40adfb9b":"9b1134b6",
    #BattleOrder
    "411029d7":"c572d354",
    #Icon
    "5c71081a":"776df0a5",
    #Profile
    "051e0f75":"0b63cfb1",
    #Splash
    "7f371cb7":"783c1349",
    #UltArt
    "5477c3b0":"e58318d8",

    # Tingyun
    #Art
    "6344bdb4":"01a61bdf",
    #BattleArt
    "5117c9fa":"032c32d3",
    #BattleOrder
    "2f320b9f":"e65dad52",
    #Icon
    "2ac02a56":"fc0f75a1",
    #Profile
    "a0e78cc3":"e63c45fe",
    #Splash
    "00ccc475":"fcc5656c",
    #UltArt
    "3d9669c6":"52290b57",

    # Topaz
    #Art
    "41126260":"00b3ff3f",
    #BattleArt
    "7c7cedcb":"585f5a33",
    #BattleOrder
    "1ce140b5":"27725a27",
    #Icon
    "88150d26":"ad166350",
    #Profile
    "d903f727":"c56d191e",
    #Splash
    #"afa38589":"",
    #UltArt
    "8297c76d":"25866b6f",

    # Xueyi
    #Art
    "151a7d68":"fcc9febd",
    #BattleArt
    "9c706ccf":"fb851c31",
    #BattleOrder
    "98ae1cdc":"f4f9920e",
    #Icon
    "1f408064":"d0873b3c",
    #Profile
    "f6b575fb":"1075212a",
    #Splash
    "9a275975":"1fb94374",
    #UltArt
    "9067272b":"a8c5fe85",

    # Yukong
    #Art
    "ab09af0e":"24ba8e2b",
    #BattleArt
    "592edd24":"db76b58c",
    #BattleOrder
    "b280dada":"5f089225",
    #Icon
    "df1a2dd9":"83bf7074",
    #Profile
    "4df5dc75":"ae19d1fb",
    #Splash
    "ebf03ded":"a417b442",
    #UltArt
    "a1dfbf61":"ed2f172b",

}


def process_folder(folder_path):
    '''Process all the files in the folder and subfolders,
    replacing the old values with the new ones.'''
    for root, dirs, files in os.walk(folder_path):
        for file in [x for x in files if x.lower().endswith('.ini') and x.lower() != 'desktop.ini']:
            file_path = os.path.join(root, file)
            print(f"--> Get in file '{file}' at '{file_path}'")
            try:
                with open(file_path, 'r', encoding="utf-8") as f:
                    s = f.read()
                    # old_stream = s
                if '[disabled1234567890]' in s:
                    print(f"Skipping file '{file}' as it already contains '[disabled1234567890]'")
                    continue
                modified = False
                for old, new in old_vs_new.items():
                    if old in s:
                        s = s.replace(old, new)
                        print(f" -  Hash '{old}' has been replase with '{new}'")
                        modified = True
                if modified:
                    backup_file_path = os.path.join(root, f"backup_{os.path.splitext(file)[0]}.txt")
                    shutil.copy2(file_path, backup_file_path)
                    print(f" -  Backup created: '{backup_file_path}'")
                    with open(file_path, 'w', encoding="utf-8") as f:
                        f.write(s)
                        print(f'<-- File has been modified!')
                else:
                    print(f'<-- File had no matches. Skipping')
            except Exception as e:
                print(f'Error processing file: {file_path}')
                print(e)
                continue

if __name__ == '__main__':
    process_folder(os.getcwd())
    input('Done!')
